<?php

/*
 * Created Dec 1, 2018 - Updated: 29.10.2020
 * HomePage: https://xentr.net
 * Copyright (c) 2019 XENTR | XenForo Add-ons - Styles -  All Rights Reserved
 */

namespace XDinc\FThread;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Alter;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;
	
	// TODO: Install Step1 method.

	public function installStep1()
	{
		$this->schemaManager()->createTable('FThread', function(Create $table)
		{
			         $table->checkExists(true);
		             $table->addColumn('thread_id', 		'int', 10);
			         $table->addColumn('fthread_date',		'int', 10);
			         $table->addColumn('fthread_time',		'int', 10);
			         $table->addColumn('fthread_title',		'varchar', 255);
			         $table->addColumn('fthread_content',	'text');
			         $table->addColumn('fthread_media',		'varchar', 255);
			         $table->addPrimaryKey('thread_id');
		});
	}
	
	// TODO: Install Step2 method.
	
	public function installStep2()
	{
		$target = \XF::getRootDirectory().'/data/FThread';
		if (!is_dir($target)) { mkdir($target, 0777); }
	}
	
	// TODO: Install Step3 method.

    public function installStep3()
    {
        $this->createWidget(
              'XD_FThread_Widget', 
              'FThreadWidget', 
					[
						'positions' => []
					]);
    }

	// TODO: Uninstall Step1 method.

	public function uninstallStep1()
	{
		$this->schemaManager()->dropTable('FThread');
	}
	
	// TODO: Uninstall Step2 method.
	
	public function uninstallStep2()
	{
		$target = glob(\XF::getRootDirectory().'/data/FThread/*.jpg');
		foreach ($target AS $file) { unlink($file); }

		$target = \XF::getRootDirectory().'/data/FThread';
		if (is_dir($target)) { rmdir($target); }
	}

}