<?php

/*
 * Created Dec 1, 2018 - Updated: 29.10.2020
 * HomePage: https://xentr.net
 * Copyright (c) 2019 XENTR | XenForo Add-ons - Styles -  All Rights Reserved
 */

namespace XDinc\FThread\Widget;

class FThreads extends \XF\Widget\AbstractWidget
{
	protected $defaultOptions = [
		'limit' => 5,
		'trim' => 200,
	];
	
	public function render()
	{   
        /*** Limit User ***/
		$visitor = \XF::visitor();				
        if (!$visitor->hasPermission('FThread_Perm', 'ft_view'))
        {
            return '';
        }
      
		$options = $this->options;
        $isAddonEnabledGlobally = \XF::options()->offsetGet('FThread_Enable');

        if(!$isAddonEnabledGlobally)
        {
            return false;
        }
        /*** Display Limit ***/
		$limit = $options['limit'];
        $limit = \XF::options()->FThread_Display_Count;

        /** @var \XDinc\FThread\Repository */
		$fthreadRepo = $this->app->repository('XDinc\FThread:FThread');

		$entries = $fthreadRepo->findFThread()->limit(max($limit * 2, 10))
			->where('Thread.discussion_state', 'visible');
		
		if (!$fthreads = $entries->fetch())
		{
			return false;
		}
		
		$fthreads = $fthreads->slice(0, $limit, true);

		$viewParams = [
			'fthreads' => $fthreadRepo->parseFThreads($fthreads, $options['trim']),
		];
		
		return $this->renderer('xtr_fthread_widget', $viewParams);
	}

	public function verifyOptions(\XF\Http\Request $request, array &$options, &$error = null)
	{
		$options = $request->filter([
			'limit' => 'uint',
			'trim' => 'uint',
		]);

		if ($options['limit'] < 1)
		{
			$options['limit'] = 1;
		}
		
		return true;
	}
}